
#include <pngwriter.h>
#include "correlation.h"
#include <string>
#include <time.h>
#include <sys/time.h>


CORRELATION::CORRELATION(const char *stIzq, const char *stDer, const char *output)
{
	Imagen = pngwriter(1,1,0, output);
	nizq = string("filtroIzq.png");
	nder = string("filtroDer.png");	
	izq = pngwriter(1,1,0, nizq.c_str());
	der = pngwriter(1,1,0, nder.c_str());
	izq.readfromfile(stIzq);
	der.readfromfile(stDer);
	X = izq.getwidth();
	Y = izq.getheight();
	Imagen.resize(X,Y);
}


float CORRELATION::calcularC1(int x, int y, int d, pngwriter &I, pngwriter &D)
{
	int limit_x = (WSIZEX - 1)/2;
	int limit_y = (WSIZEY - 1)/2;
	int i, j;
	double IxD=0, I2=0, D2=0;

	
	for(i = -limit_x; i <= limit_x; i++)
		for(j = -limit_y; j <= limit_y; j++)
			IxD += pow(I.read(x+i,y+j)-D.read(x+d+i,y+j), 2);

	for(i = -limit_x; i <= limit_x; i++)
		for(j = -limit_y; j <= limit_y; j++)
			D2 += pow(D.read(x+d+i, y+j) , 2);
					
	//~ for(i = -limit_x; i <= limit_x; i++)
		//~ for(j = -limit_y; j <= limit_y; j++)
			//~ I2 += pow(I.read(x+i,y+j) , 2);
	I2 = 1;

	D2 = sqrt(D2);
	I2 = sqrt(I2);
	
	return IxD/(D2*I2);
}

float CORRELATION::calcularC2(int x, int y, int d, pngwriter &I, pngwriter &D)
{
	int limit_x = (WSIZEX - 1)/2;
	int limit_y = (WSIZEY - 1)/2;
	int i, j;
	double IxD=0, I2=0, D2=0;

	
	for(i = -limit_x; i <= limit_x; i++)
		for(j = -limit_y; j <= limit_y; j++)
			IxD += I.read(x+i,y+j)*D.read(x+d+i,y+j);

	for(i = -limit_x; i <= limit_x; i++)
		for(j = -limit_y; j <= limit_y; j++)
			D2 += pow(D.read(x+d+i, y+j) , 2);
					
	//~ for(i = -limit_x; i <= limit_x; i++)
		//~ for(j = -limit_y; j <= limit_y; j++)
			//~ I2 += pow(I.read(x+i,y+j) , 2);
	I2=1;
	
	D2 = sqrt(D2);
	I2 = sqrt(I2);
	
	return IxD/(D2*I2);
}

void CORRELATION::setsize()
{
	Imagen.resize(X,Y);
}

void CORRELATION::setsize(int a, int b)
{
	Imagen.resize(a,b);
}

void CORRELATION::guardar()
{
	Imagen.close();
	izq.close();
	der.close();
	
}

void CORRELATION::filtraInputs()
{
	filtro(izq, nizq);
	filtro(der, nder);
}

void CORRELATION::maximizar()
{
	int d, dMax, x ,y, dMax2;
	float valor, valorMAX=0, valorMAX2=0;
	int i=1, j=1;

	
	for(x = 1; x <= X; x++, i++)
	{
		for(y = 1; y <= Y; y++, j++)
		{
			for(d = -WSEARCH/2; d <= WSEARCH/2; d++)			// busqueda del mejor "d"
			{
				valor = calcularC2(x,y,d,izq,der);			
				if (valor > valorMAX)
				{
					valorMAX = valor;
					dMax = d;
				}
			}
			
			//~ valorMAX2 = 0;
			//~ for(d = -WSEARCH/2; d <= WSEARCH/2; d++)			// validacion
			//~ {
				//~ valor = calcularC2(dMax+x,y,d,D,I);			
				//~ if (valor > valorMAX2)
				//~ {
					//~ valorMAX2 = valor;
					//~ dMax2 = d;
				//~ }
			//~ }
			//~ if(dMax2 == dMax*-1)
				//~ dMax = (int) 65535*(dMax + WSEARCH/2)/WSEARCH;
			//~ else
				//~ dMax = 65535;

			dMax = (int) 65535*(dMax + WSEARCH/2)/WSEARCH;
			Imagen.plot(i,j,dMax,dMax,dMax);
			valorMAX = 0;
			dMax = 0;	
			dMax2= 0;
		}
		j = 1;
	}
}

void CORRELATION::minimizar()
{
	int d, x ,y, dMax, dMax2;
	int i=1, j=1;
	float valor, valorMIN=999999, valorMIN2=999999;
	float MIN=9999999;
	float MAX=0;
	
	for(x = 1; x <= X; x++, i++)
	{
		for(y = 1; y <= Y; y++, j++)
		{
			for(d = -WSEARCH/2; d <= WSEARCH/2; d++)			// busqueda del mejor "d"
			{
				valor = calcularC1(x,y,d,izq,der);			
				if (valor < valorMIN)
				{
					valorMIN = valor;
					dMax = d;
				}
			}
			
			valorMIN2 = 9999999;
			for(d = -WSEARCH/2; d <= WSEARCH/2; d++)			// validacion
			{
				valor = calcularC1(dMax+x,y,d,der,izq);			
				if (valor < valorMIN2)
				{
					valorMIN2 = valor;
					dMax2 = d;
				}
			}
			
			if(dMax2 == dMax*-1)
				dMax = (int) 65535*(dMax + WSEARCH/2)/WSEARCH;
			else
				dMax = 65535;
			Imagen.plot(i,j,dMax,dMax,dMax);
			valorMIN = 9999999;
			dMax = 0;
			dMax2=0;
		}
		j = 1;
	}

}

void CORRELATION::filtro(pngwriter &im, string name)
{
	int i,j,x,y,suma,div=0;
	
	int mask[3][3]={{1,-1,1},{-1,8,-1},{1,-1,1}}; //La mejor para minimizar
	
	pngwriter aux(X,Y,0,"aux");
	
	for(i=0; i< 3; i++)
		for(j=0; j<3; j++)
			div += mask[i][j];
	if(div == 0)
		div = 1;
	
	for(i=1; i <= X; i++)
		for(j=1; j<= Y; j++)
		{
			for(x=-1; x <= 1; x++)
				for(y=-1; y <= 1; y++)
					suma = suma + im.read(i+x, j+y)*mask[x+1][y+1];
			suma = (suma/div)*256;
			aux.plot(i,j,suma,suma,suma);
			suma = 0;
		}
	im = aux;
	im.pngwriter_rename(name.c_str());
	
}


#define SWAP(a, b) { t=a; a=b; b=t; }
#define compGT(a, b) (a > b)
void ordenar(int *a)
{
	int i, j;
	int t; //temporal
	int Inf = 0, Sup=8;
	
	/* Recorre con i el arreglo desde Inf hasta Sup */
	for(i=Inf ; i<= Sup; i++)
	{
		/* Recorre con j, desde el siguiente a Inf hasta el final de la zona no ordenada */
		for(j=Inf+1; j<=(Sup-(i-Inf)); j++)
		{ /* Ordena elementos adyacentes, intercambiándolos */
			if( compGT( a[j-1], a[j] ) )
				SWAP(a[j-1], a[j]);
		}
	}
}


void CORRELATION::mediana()
{
	int a[9];
	int i,j,x,y, n=0;
	
	pngwriter aux = Imagen;
	
	for(i=1; i <= X; i++)
		for(j=1; j<= Y; j++)
		{
			for(x=-1; x <= 1; x++)
				for(y=-1; y <= 1; y++, n++)
					 a[n]= Imagen.read(i+x,j+y);
			n =0;
			ordenar(a);
			aux.plot(i,j, a[4],a[4],a[4]);
		}
	Imagen = aux;
}


void CORRELATION::fillin()
{
	int i,j,x,y,suma=0,h=0;
	
	
	for(i=1; i <= X; i++)
		for(j=1; j<= Y; j++)
		{
			if(Imagen.read(i,j)==65535)
			{
				for(x=-1; x <= 1; x++)
					for(y=-1; y <= 1; y++)
						if(Imagen.read(i+x, j+y)==65535)
							continue;
						else
						{
							suma = suma + Imagen.read(i+x, j+y);
							h++;
						}
					if (suma == 0) continue;	
					suma = (suma/h);
					Imagen.flood_fill(i,j,suma,suma,suma);
					h=0;
					suma = 0;
			}
		}
}

void CORRELATION::fillin2()
{
	int i,j,x,y,v,suma=0,h=0, n=0;
	bool fill[9];
	
	pngwriter Imagen2(X,Y,0,"xxx.png");
	
	for(i=1; i <= X; i++)
		for(j=1; j<= Y; j++)
			Imagen2.plot(i,j,1.0,0.2,0.4);
			
	for(x=0; x < 9; x++)
		fill[x]=false;
	
		for(i=1; i <= X; i++)
			for(j=1; j<= Y; j++)
			{
				if((Imagen.read(i,j)>=64000) or (Imagen.read(i,j) <= 2000))
				{
					Imagen2.plot(i,j,Imagen.read(i,j),Imagen.read(i,j),Imagen.read(i,j));
					for(x=-1; x <= 1; x++)
						for(y=-1; y <= 1; y++)
						{
							if((Imagen.read(i+x, j+y)>= 64000) or (Imagen.read(i+x,j+y) <= 2000))
							{
								fill[n]= true;
								continue;
							}
							else
							{
								suma = suma + Imagen.read(i+x, j+y);
								h++;
							}
							n++;
						}
					
					if (h == 0) continue;	
					suma = (suma/h);
					n=0;
					for(x=-1; x <= 1; x++)
						for(y=-1; y <= 1; y++)
						{
							if(fill[n])
								Imagen.plot(i+x,j+y,suma,suma,suma);
							n++;
						}
					h=0;
					suma = 0;
					n=0;
					for(x=0; x < 9; x++)
						fill[x]=false;
				}
			}
}

void CORRELATION::contraste()
{
	int i,j,x,y;
	double v, max =0, min=99999;
	
	
	for(i=1; i <= X; i++)
		for(j=1; j<= Y; j++)
		{
			v = Imagen.dread(i,j);
			if(v > max) max = v;
			if(v < min) min = v;
		}
	for(i=1; i <= X; i++)
		for(j=1; j<= Y; j++)
			{
				v=(Imagen.dread(i,j)-min)/(max-min);
				Imagen.plot(i,j,v,v,v);
			}
}

int main(void)
{
	struct timeval tim;
	int t1, t2;
	
	gettimeofday(&tim, NULL);
	t1=tim.tv_sec;
	CORRELATION aux("izq.png", "der.png", "mapa.png");
	
	cout << "filtraInputs()\n";
	aux.filtraInputs();
	
	cout << "minimizar()\n";
	aux.minimizar();
	
	cout << "mediana()\n";
	aux.mediana();
	
	cout << "fillin()\n";
	aux.fillin2();
	
	cout << "mediana()\n";
	aux.mediana();
	
	cout << "contraste()\n";
	aux.contraste();
	
	cout << "guardar()\n";
	aux.guardar();
	
	gettimeofday(&tim, NULL);
	t2=tim.tv_sec;
	
	cout << "\nTiempo total de ejecución: " << t2-t1 << " [s]\n";
	
	return 0;

}
